//-------------------------------------------------------------------------------
/**
*	This program is distributed under the terms of the GNU Lesser General
*	Public License (LGPL). 
*
*	ASSIMP Viewer Utility
*
*/
//-------------------------------------------------------------------------------

#pragma once


namespace AssimpRendererD3d
{
	/// Class to manage the global render options for all Assets.
	/**	This is needed as an argument when calling AssimpRenderer::CreateD3dDevice()
	*/
	class RenderOptions
	{
	public:

		inline RenderOptions	(void) :
			bMultiSample	(true),			// WAR: true			
			bLowQuality		(false),
			bNoSpecular		(false) {}

		/// use multiSampling
		bool bMultiSample;

		/// use standard lambertian lighting
		bool bLowQuality;

		/// disable specular lighting all elements in the scene
		bool bNoSpecular;

	};
} // namespace
